#!/usr/bin/python
#-*- coding:Utf-8 -*-

#Special thanks to James Kassemi for the timed event class! That part of code is from here: code.activestate.com/recipes/496800-event-scheduling-threadingtimer/

import thread
import threading 
import time
from time import mktime
#import socket
#import sys
import sqlite3 as sql
import gconf
#import subprocess
import datetime
from datetime import date
from datetime import datetime
#import dbus
import os

#bus = dbus.SystemBus()
#iface = dbus.Interface(bus.get_object('com.nokia.icd2','/com/nokia/icd2'),'com.nokia.icd2')

def ConnectionStatus():
  #state = iface.state_req()
  cmd = "dbus-send --print-reply --system --dest=com.nokia.icd2 /com/nokia/icd2 com.nokia.icd2.state_req | sed -n '2p' | awk {'print $2'} | tr -d '\n'"
  temp = os.popen(cmd)
  state = temp.read()
  return state

class Operation(threading._Timer):
    def __init__(self, *args, **kwargs):
        threading._Timer.__init__(self, *args, **kwargs)
        self.setDaemon(True)

    def run(self):
        while True:
            self.finished.clear()
            self.finished.wait(self.interval)
            if not self.finished.isSet():
                self.function(*self.args, **self.kwargs)
            else:
                return
            self.finished.set()

class Manager(object):

    ops = []

    def add_operation(self, operation, interval, args=[], kwargs={}):
        op = Operation(interval, operation, args, kwargs)
        self.ops.append(op)
        thread.start_new_thread(op.run, ())

    def stop(self, operation):
        for op in self.ops:
          if operation == op:
            op.cancel()
        #self._event.set()

###################################################################

client = gconf.client_get_default()
client.add_dir("/apps/connui-cellular", gconf.CLIENT_PRELOAD_NONE)
database = sql.connect("/home/user/.calendar/calendardb", check_same_thread = False)
task = database.cursor()

def CheckingEvent():
  today = date(int(time.strftime("%Y")),int(time.strftime("%m")),int(time.strftime("%d")))
  today_unix = mktime(today.timetuple())
  tomorrow_unix = today_unix+86400
  task.execute("select Summary from Components where DateStart >= '"+str(int(today_unix))+"' and DateStart < '"+str(int(tomorrow_unix)-1)+"';")
  row = task.fetchall()
  event = str(len(row))
  return  event

def CheckingBirthday():
  task.execute("select DateStart,Summary from Components where ComponentType='4' and AllDay='1' and Flags='3';")
  celebs = []
  while True:
    row = task.fetchone()
    if row == None:
      break
    else:
      if datetime.fromtimestamp(int(row[0])).strftime("%m/%d") == time.strftime("%m/%d"):
        celebs.append(row[1])
  return str(len(celebs))

def Date():
  now = datetime.now()
  current_date = now.strftime('%H:%M | %a %d %b %Y')
  return current_date

###Special thanks to the thread pause using set() and clear() events for Rich, found on stackoverflow.com/questions/3262346/pausing-a-thread-using-threading-class###

def Refreshing(e):
  while True:
    e.wait()
    cmd = "sudo /opt/onr/GetWeatherInfo"
    os.system(cmd)
    #subprocess.call(cmd)
    cmd = "sudo /opt/onr/GetMoonInfo"
    os.system(cmd)
    #subprocess.call(cmd)
    time.sleep(800)
    e.clear()

e = threading.Event()
t = threading.Thread(target = Refreshing, args=(e, ))

def CheckingWirelessStatus():
  #Trying to make socket connection
  ##try:
    #s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
  ##except socket.error:
    ##print "%s" %(socket.error)
  #port = 80
  #Trying to resolve the host (i.e. connect to the internet)
  ##try:
    ##host = 'rss.accuweather.com' #define host (i.e. website)
    ##ip = socket.gethostbyname(host) #getting IP address here
    #print ip
    ##status = 1
    #s.connect((ip, port))
    #s.close()
  ##except socket.gaierror:
    ##status = 0
    #print "CouldNotResolveHost..."
    ##pass
    #sys.exit()
  if ConnectionStatus() == "1":
    if t.isAlive() != False:
      e.set()
    else:
      t.setDaemon(True)
      t.start()
  elif ConnectionStatus() == "0":
    if t.isAlive() != False:
      e.clear()
  f = open("/opt/onr/weatherdata", 'r')
  l = f.readlines()
  if len(l) == 8:
    weather_now = l[0][0:len(l[0])-2]
    weather_today = l[3][0:len(l[3])-2]
    weather_tomorrow = l[6][0:len(l[6])-2]
    f = open("/opt/onr/mooninfo", 'r')
    l = f.readlines()
    if len(l) == 9:
      if "Waning" in l[3]:
        moon = l[0][0:len(l[0])-1]+" -"
      elif "Third" in l[3]:
        moon = l[0][0:len(l[0])-1]+" -"
      elif "Waxing" in l[3]:
        moon = l[0][0:len(l[0])-1]+" +"
      elif "First" in l[3]:
        moon = l[0][0:len(l[0])-1]+" +"
      elif "Full" in l[3]:
        moon = l[0][0:len(l[0])-1]
      elif "New" in l[3]:
        moon = l[0][0:len(l[0])-1]
    elif len(l) != 9:
      moon = "N.A."
    weather_data = weather_now+" | "+moon+"\n"+weather_today+"\n"+weather_tomorrow
  elif len(l) != 8:
    weather_data = "N.A."+"\n"*3
  #return {'weather_data':weather_data, 'status':status
  return weather_data

def Battery():
  cmd = """hal-device bme | grep percentage | awk {'print $3"%"'} | tr -d '\n'"""
  temp = os.popen(cmd)
  batt = temp.read()
  return batt

def PrintData(current_date,birthday,event,batt,weather_data):
  client.set_string("/apps/connui-cellular/operator_name_online",current_date+"\n"+" | "+birthday+" | "+event+" | "+batt+"\n"+weather_data)

def GetData():
  PrintData(Date(),CheckingBirthday(),CheckingEvent(),Battery(),CheckingWirelessStatus())

def MemoryCheck():
  pid = "pidof python /opt/onr/ONR.py | awk {'print $1'} | tr -d '\n'"
  temp = os.popen(pid)
  PID = temp.read()
  mem = "top -n 1 | grep "+PID+" | awk {'print $6'} | tr -d '\n'"
  temp = os.popen(mem)
  MEM = temp.read()
  if MEM >= "3.0":
    cmd = 'sudo /etc/init.d/onr restart'
    os.system(cmd)

if __name__ == '__main__':

  timer = Manager()
  timer.add_operation(GetData, 2)
  timer2 = Manager()
  timer2.add_operation(MemoryCheck, 60)


  while True:
      time.sleep(.1)
